#ifndef _XSparkleShader_H_
#define _XSparkleShader_H_

enum
{


	SCA_READ = 7000,
	SCA_STORE = 7001,
	SCA_FILENAME = 7002,



	SCA_MAT_PREVIEW = 1001,

	SCA_BLEND_TOPMOST = 2000,
	SCA_BLEND_BRIGHTEST = 2001,

	SCA_TYPE_ELLIPSOID = 1006,
	SCA_TYPE_CUBOID = 1007,
	SCA_TYPE_TETRAEDER = 1008,
	ID_GLOBAL = 2002,
	ID_EXCLUDE_LIGHTS = 2003,
	
	SCA_EXCLUSION_MODE = 2004,
	SCA_EXCLUSION_MODE_INCLUDE = 2005,
	SCA_EXCLUSION_MODE_EXCLUDE = 2006,

	SCA_EXCLUSION_LIST= 2007,
	SCA_GLOBAL_RAYDEPTH = 2008,
	SCA_TXT_GLOBAL_RAYTRACING = 2009,
	SCA_TXT_GLOBAL_LIGHTINEXCLUDSION = 2010,
	 
	SCA_PHONG_MASK1 = 2011,
	SCA_PHONG_MASK2 = 2012,
	SCA_PHONG_MASK3 = 2013,
	SCA_PHONG_MASK4 = 2014,
	SCA_PARTICLE_BLENDG = 2015,
	SCA_GBLEND_TOPMOST = 2016,
	SCA_GBLEND_ADD = 2017,
	SCA_GBLEND_SUB = 2018,
	SCA_GBLEND_MULT = 2019,
	SCA_FORCE_USE_UVW = 2020,
	SCA_GLOBAL_SEED = 2021,

	SCA_DO_LINK_SHADER = 2022,
	SCA_LINK_SHADER_NAME = 2023,
	TEST_BUTTON = 2024,

	SCA_FMODE_DISABLED = 2025,
	SCA_FMODE_STYLE1 = 2026,
	SCA_FMODE_STYLE2 =  2027,
	SCA_FMODE_STYLE3 =  2028,
	SCA_FMODE_STYLE4 = 2029,
	
	SCA_BB_FULL_PARTICLE = 2041,
	SCA_BB_CUT_PARTICLE = 2042,

	SCA_FMODE_STRENGTH_VERY_WEAK  = 2043,
	SCA_FMODE_STRENGTH_WEAK   = 2044,
	SCA_FMODE_STRENGTH_MEDIUM   = 2045,
	SCA_FMODE_STRENGTH_STRONG   = 2046,
	SCA_FMODE_STRENGTH_VERY_STRONG   = 2047,

	SCA_FMODE_CUTOFF_NONE = 2048,
	SCA_FMODE_CUTOFF_SUPERDUPERRWEAK = 2046,
	SCA_FMODE_CUTOFF_SUPERWEAK = 2049,
	SCA_FMODE_CUTOFF_VERYWEAK = 2050,
	SCA_FMODE_CUTOFF_WEAK = 2051,
	SCA_FMODE_CUTOFF_MEDIUM = 2052,
	SCA_FMODE_CUTOFF_STRONG = 2053,
	SCA_FMODE_CUTOFF_VERYSTRONG = 2054,
	SCA_FMODE_CUTOFF_SUPERSTRONG = 2055,
	SCA_FMODE_CUTOFF_SUPERDUPERSTRONG = 2057,
	
	SCA_TXT_SPARKLING1 = 2056,
	SCA_TXT_SPARKLING2 = 2057,
	SCA_TXT_SPARKLING3 = 2058,
	SCA_TXT_SPARKLING4 = 2059,
	
	SCA_GLOBAL_GRID_SCALE = 2060,
	SCS_BASE_COLOR = 2061,
	SCA_GLOBAL_BRIGHNESS = 2062,
	SCA_ALLOW_DARK_PARTICLES = 2063,





	//Shader 1
	ID_SCATTERSHADER1 = 1002,
	SCA_LAYERCOUNT1 = 1004,
	SCA_GRIDSIZE1 = 1010,
	SCA_PARTICLE_FORM_VARIATION1 = 1015,

	SCA_PARTICLE_MAX_ANGLE1 = 1016,
	SCA_SPECULAR_WIDTH1 = 1017,
	SCA_PHONG_STRENGTH1 = 1018,
	ID_REFLECTION1 = 1019,
	SCA_USE_REFLECTION1 = 1020,
	SCA_REFLECTION_STRENGTH1 = 1021,
	SCA_USE_SURFACE_NORMAL_FOR_REFLECTION1 = 1022,

	ID_USEFRESNEL1 = 1024,
	SCA_USE_FRESNEL1 = 1025,
	SCA_FRESNEL_GRADIENT1 = 1026,
	SCA_PARTICLE_DENSITY1 = 1028,
	SCA_TRACE_DEPTH1 = 1029,
	SCA_TXT_PARTICLE_DISTRIBUTION1 = 1030,
	SCA_TXT_LIGHT_CONTROL1 = 1031,
	SCA_ENABLE_SHADER1 = 1032,
	SCA_PARTICLE_TYPE1 = 1033,
	SCA_PARTICLE_BLEND1 = 1034,
	SCA_TRACE_DISTANCE1 = 1035,
	ID_MAPS1  = 1036,
	SCS_MAP_DENSITY1 = 1037,
	SCS_MAP_MAX_ANGLE1 = 1038,
	SCS_MAP_SPEC_STRENGTH1 = 1039,
	SCS_MAP_SPEC_FALLOFF1 = 1040,
	SCS_MAP_REFL_STRENGTH1 = 1041,
	SCS_MAP_COLOR1 = 1042,
	SCS_MAP_FORM_VARIATION1 = 1043,
	SCA_ONE_COLOR_PER_PARTICLE1 = 1044,
	SCA_ONE_C_NOTE1 = 1045,
	SCA_COLORIZE_REFLECTION1 = 1046,
	SCA_PARTICLE_NORMAL_DEVIATION1 = 1047,
	SCS_MAP_MAX_DEVIATION1 = 1048,
	SCA_FMODE1 = 1049,
	SCA_BLEND_BEHAVIOR1 = 1050,
	SCA_FMODE_STRENGTH1 = 1052,
	SCA_FMODE_CUTOFF1 = 1053,
	SCA_DO_NOT_COLOR_SPECULAR1 = 1054,
	SCA_IOR1 = 1055,
	SCS_FRESNEL_SHADER1 = 1057,
	SCA_USE_FRESNEL_GRADIENT1 = 1058,
	SCA_COLORIZE_SPECULAR1 = 1059,




	//Shader 2
	SCA_ENABLE_SHADER2 = 1103,
	ID_SCATTERSHADER2 = 1080,
	SCA_LAYERCOUNT2 = 1082,
	SCA_GRIDSIZE2 = 1084,
	SCA_PARTICLE_FORM_VARIATION2 = 1089,

	SCA_PARTICLE_MAX_ANGLE2 = 1090,
	SCA_SPECULAR_WIDTH2 = 1091,
	SCA_PHONG_STRENGTH2 = 1092,
	ID_REFLECTION2 = 1093,
	SCA_USE_REFLECTION2 = 1094,
	SCA_REFLECTION_STRENGTH2 = 1095,
	SCA_USE_SURFACE_NORMAL_FOR_REFLECTION2 = 1096,

	ID_USEFRESNEL2 = 1097,
	SCA_USE_FRESNEL2 = 1098,
	SCA_FRESNEL_GRADIENT2 = 1099,
	SCA_PARTICLE_DENSITY2 = 1100,
	SCA_TRACE_DEPTH2 = 1101,
	SCA_TXT_PARTICLE_DISTRIBUTION2 = 1102,
	SCA_TXT_LIGHT_CONTROL2 = 1104,
	SCA_PARTICLE_TYPE2 = 1105,
	SCA_PARTICLE_BLEND2 = 1106,
	SCA_TRACE_DISTANCE2 = 1107,

	ID_MAPS2  = 1108,
	SCS_MAP_DENSITY2 = 1109,
	SCS_MAP_MAX_ANGLE2 = 1110,
	SCS_MAP_SPEC_STRENGTH2 = 1111,
	SCS_MAP_SPEC_FALLOFF2 = 1112,
	SCS_MAP_REFL_STRENGTH2 = 1113,
	SCS_MAP_COLOR2 = 1114,
	SCS_MAP_FORM_VARIATION2 = 1115,
	SCA_ONE_COLOR_PER_PARTICLE2 = 1116,
	SCA_ONE_C_NOTE2 = 1117,
	SCA_COLORIZE_REFLECTION2 = 1118,
	SCA_PARTICLE_NORMAL_DEVIATION2 = 1119,
	SCS_MAP_MAX_DEVIATION2 = 1120,
	SCA_FMODE2 = 1121,
	SCA_BLEND_BEHAVIOR2 = 1122,
	SCA_FMODE_STRENGTH2 = 1123,
	SCA_FMODE_CUTOFF2 = 1124,
	SCA_DO_NOT_COLOR_SPECULAR2 = 1125,
	SCA_PARTICLE_BLENDFL2 = 1126,
	SCS_FRESNEL_SHADER2 = 1128,
	SCA_USE_FRESNEL_GRADIENT2 = 1129,
	SCA_COLORIZE_SPECULAR2 = 1130,



	//Shader 3
	SCA_ENABLE_SHADER3 = 4000,
	ID_SCATTERSHADER3 = 4001,
	SCA_LAYERCOUNT3 = 4002,
	SCA_GRIDSIZE3 = 4003,
	SCA_PARTICLE_FORM_VARIATION3 = 4004,

	SCA_PARTICLE_MAX_ANGLE3 = 4005,
	SCA_SPECULAR_WIDTH3 = 4006,
	SCA_PHONG_STRENGTH3 = 4007,
	ID_REFLECTION3 = 4008,
	SCA_USE_REFLECTION3 = 4009,
	SCA_REFLECTION_STRENGTH3 = 4010,
	SCA_USE_SURFACE_NORMAL_FOR_REFLECTION3 = 4011,

	ID_USEFRESNEL3 = 4012,
	SCA_USE_FRESNEL3 = 4013,
	SCA_FRESNEL_GRADIENT3 = 4014,
	SCA_PARTICLE_DENSITY3 = 4015,
	SCA_TRACE_DEPTH3 = 4016,
	SCA_TXT_PARTICLE_DISTRIBUTION3 = 4017,
	SCA_TXT_LIGHT_CONTROL3 = 4018,
	SCA_PARTICLE_TYPE3 = 4019,
	SCA_PARTICLE_BLEND3 = 4020,
	SCA_TRACE_DISTANCE3 = 4021,

	ID_MAPS3  = 4021,
	SCS_MAP_DENSITY3 = 4022,
	SCS_MAP_MAX_ANGLE3 = 4023,
	SCS_MAP_SPEC_STRENGTH3 = 4024,
	SCS_MAP_SPEC_FALLOFF3 = 4025,
	SCS_MAP_REFL_STRENGTH3 = 4026,
	SCS_MAP_COLOR3 = 4027,
	SCS_MAP_FORM_VARIATION3 = 4028,
	SCA_ONE_COLOR_PER_PARTICLE3 = 4029,
	SCA_ONE_C_NOTE3 = 4030,
	SCA_COLORIZE_REFLECTION3 = 4031,
	SCA_PARTICLE_NORMAL_DEVIATION3 = 4032,
	SCS_MAP_MAX_DEVIATION3 = 4033,
	SCA_FMODE3 = 4034,
	SCA_BLEND_BEHAVIOR3 = 4035,
	SCA_FMODE_STRENGTH3 = 4036,
	SCA_FMODE_CUTOFF3 = 4037,
	SCA_DO_NOT_COLOR_SPECULAR3 = 4038,
	SCA_PARTICLE_BLENDFL3 = 4039,
	SCS_FRESNEL_SHADER3 = 4041,
	SCA_USE_FRESNEL_GRADIENT3 = 4042,
	SCA_COLORIZE_SPECULAR3 = 4043,


	//Shader 4
	SCA_ENABLE_SHADER4 = 5000,
	ID_SCATTERSHADER4 = 5001,
	SCA_LAYERCOUNT4 = 5002,
	SCA_GRIDSIZE4 = 5003,
	SCA_PARTICLE_FORM_VARIATION4 = 5004,

	SCA_PARTICLE_MAX_ANGLE4 = 5005,
	SCA_SPECULAR_WIDTH4 = 5006,
	SCA_PHONG_STRENGTH4 = 5007,
	ID_REFLECTION4 = 5008,
	SCA_USE_REFLECTION4 = 5009,
	SCA_REFLECTION_STRENGTH4 = 5010,
	SCA_USE_SURFACE_NORMAL_FOR_REFLECTION4 = 5011,

	ID_USEFRESNEL4 = 5012,
	SCA_USE_FRESNEL4 = 5013,
	SCA_FRESNEL_GRADIENT4 = 5014,
	SCA_PARTICLE_DENSITY4 = 5015,
	SCA_TRACE_DEPTH4 = 5016,
	SCA_TXT_PARTICLE_DISTRIBUTION4 = 5017,
	SCA_TXT_LIGHT_CONTROL4 = 5018,
	SCA_PARTICLE_TYPE4 = 5019,
	SCA_PARTICLE_BLEND4 = 5020,
	SCA_TRACE_DISTANCE4 = 5021,

	ID_MAPS4  = 5021,
	SCS_MAP_DENSITY4 = 5022,
	SCS_MAP_MAX_ANGLE4 = 5023,
	SCS_MAP_SPEC_STRENGTH4 = 5024,
	SCS_MAP_SPEC_FALLOFF4 = 5025,
	SCS_MAP_REFL_STRENGTH4 = 5026,
	SCS_MAP_COLOR4 = 5027,
	SCS_MAP_FORM_VARIATION4 = 5028,
	SCA_ONE_COLOR_PER_PARTICLE4 = 5029,
	SCA_ONE_C_NOTE4 = 5030,
	SCA_COLORIZE_REFLECTION4 = 5031,
	SCA_PARTICLE_NORMAL_DEVIATION4 = 5032,
	SCS_MAP_MAX_DEVIATION4 = 5033,
	SCA_FMODE4 = 5034,
	SCA_BLEND_BEHAVIOR4 = 5035,
	SCA_FMODE_STRENGTH4 = 5036,
	SCA_FMODE_CUTOFF4 = 5037,
	SCA_DO_NOT_COLOR_SPECULAR4 = 5038,
	SCA_PARTICLE_BLENDFL4 = 5039,
	SCS_FRESNEL_SHADER4 = 5041,
	SCA_USE_FRESNEL_GRADIENT4 = 5042,
	SCA_COLORIZE_SPECULAR4 = 5043,


};

#endif


